package ru.dbotthepony.mc.otm.client.screen

import net.minecraft.network.chat.Component
import net.minecraft.world.entity.player.Inventory
import ru.dbotthepony.mc.otm.client.screen.panels.Dock
import ru.dbotthepony.mc.otm.client.screen.panels.FramePanel
import ru.dbotthepony.mc.otm.client.screen.panels.TextInputPanel
import ru.dbotthepony.mc.otm.menu.HoloSignMenu
import ru.dbotthepony.mc.otm.milliTime

class HoloSignScreen(menu: HoloSignMenu, inventory: Inventory, title: Component) : MatteryScreen<HoloSignMenu>(menu, title) {
	override fun makeMainFrame(): FramePanel<MatteryScreen<*>> {
		val frame = FramePanel(this, null, 0f, 0f, 200f, 200f, getTitle())

		object : TextInputPanel<HoloSignScreen>(this@HoloSignScreen, frame) {
			init {
				dock = Dock.FILL
				multiLine = true
			}

			private var lastChanges = 0L

			override fun onTextChanged(old: String, new: String) {
				lastChanges = milliTime + 1000L
				menu.textInput.input(new)
			}

			override fun tick() {
				super.tick()

				if (milliTime >= lastChanges) {
					text = menu.text
				}
			}
		}

		return frame
	}
}
