package ru.dbotthepony.mc.otm.menu

import net.minecraft.world.entity.player.Inventory
import net.minecraft.world.inventory.Slot
import ru.dbotthepony.mc.otm.block.entity.decorative.HoloSignBlockEntity
import ru.dbotthepony.mc.otm.core.util.BinaryStringCodec
import ru.dbotthepony.mc.otm.registry.MMenus

class HoloSignMenu @JvmOverloads constructor(
	containerId: Int,
	inventory: Inventory,
	tile: HoloSignBlockEntity? = null
) : MatteryMenu(MMenus.HOLO_SIGN, containerId, inventory, tile) {
	var text by mSynchronizer.string(name = "text")

	val textInput = PlayerInput(BinaryStringCodec) {
		if (tile is HoloSignBlockEntity)
			tile.text = it
	}

	override val storageSlots: Collection<Slot>
		get() = listOf()

	override fun broadcastChanges() {
		super.broadcastChanges()

		if (tile is HoloSignBlockEntity)
			text = tile.text
	}
}
